#ifndef _Page5IntDoTh_
#define _Page5IntDoTh_

typedef struct PgId_s{
  int proc;
  int pgnum;
} PgId;

/* This information is kept for every page that's in memory.  At the
   very least, it must contain a back-pointer back into the pgtbl, so
   we know which page we are actually talking about and information about
   whether the page is locked or dirty.  We keep some additional stats
   that might be useful for statistical analysis, swapping protocol
   decision-making, etc. ... */
typedef struct {
  struct PgId_s id;
  int refcnt;
  int dirty;			/* one bit - must be written back to disk
				 before discarding. */
  int expired;			/* one bit - don't trust this data.  Get
				 it from disk if it's needed again. */
  int hits;			/* number of hits on this mem-object */
  int timestamp;		/* when was it brought in? */
  void *base;
} inmeminfo;

#endif
