#include <stdlib.h>
#include "tree.h"
#include "traverse.h"
#include "Msgs.h"

void 
TraverseSg(oocptr sgooc, Mac_t mac, DoBodies_t visitbods){
  sib_group *sg;
  PgHndl sghndl;
  int nc, i;

  sg = OOCFollow(sgooc, &sghndl);
  if( visitbods )
    (*visitbods)(sg);

  nc = sg->ncell;
  for(i=0; i<nc; i++){
    if( (*mac)(sg->key, &sg->tcells[i])==MAC_REJECT ){
      TraverseSg(sg->tcells[i].daughter, mac, visitbods);
    }
  }

  PgUnref(sghndl, PG_CLEAN);
}

void 
TraverseSg3(oocptr sgooc, sgMac3_t visitsg){
  sib_group *sg;
  PgHndl sghndl;
  int nreject, i;
  const tcell **rejects;

  sg = OOCFollow(sgooc, &sghndl);
  rejects = alloca(sg->ncell*sizeof(tcell *));
  nreject = (*visitsg)(sg, sghndl, rejects);
  assert(nreject <= sg->ncell && nreject >= 0);

  for(i=0; i<nreject; i++){
    TraverseSg3(rejects[i]->daughter, visitsg);
  }

  PgUnref(sghndl, PG_CLEAN);
}

