#include <stdarg.h>
#include <stdio.h>
#include "protos.h"
#include "mpmy.h"
#include "Msgs.h"
#include "singlio.h"

static int singl_auto_flush;
int singlioMsg = 0;

int singlAutoflush(int new){
    int ret = singl_auto_flush;
    singl_auto_flush = new;
    return ret;
}

int singlPrintf(const char *fmt, ...){
    va_list ap;
    int ret;

    if(MPMY_Procnum() == 0 ){
      va_start(ap, fmt);
      ret = vfprintf(stdout, fmt, ap);
      va_end(ap);
      if( singl_auto_flush )
	fflush(stdout);
    }else{
      ret = 0;
    }

    /* Put it in the msgs output too.  */
    if( singlioMsg ){
      va_start(ap, fmt);
      Msg_doalist(fmt, ap);
      if( singl_auto_flush )
	Msg_flush();
      va_end(ap);
    }
    return ret;
}

void singlFflush(void)
{
    if( MPMY_Procnum() != 0 )
	return;
    fflush(stdout);
}
