/* The simplest possible two-node program. */
#include "mpmy.h"
#include <stdio.h>
#include "protos.h"

int main(int argc, char **argv){
    int procnum, hisproc, nproc;
    MPMY_Comm_request send_hndl, recv_hndl;
    MPMY_Status stat;

    MPMY_Init(&argc, &argv);
    procnum = MPMY_Procnum();
    nproc = MPMY_Nproc();

    if( procnum == (nproc-1) && nproc%2 ){
	printf("Proc: %d has no partner.  Exiting.\n", procnum);
	exit(0);
    }

    MPMY_Isend(&procnum, sizeof(procnum), procnum^1, 1001, &send_hndl);
    MPMY_Irecv(&hisproc, sizeof(hisproc), procnum^1, 1001, &recv_hndl);

    MPMY_Wait(send_hndl, NULL);
    MPMY_Wait(recv_hndl, &stat);
    printf("Proc: %d, received %d from %d: %d\n", 
	   procnum, MPMY_Count(&stat), MPMY_Source(&stat), hisproc);
    exit(0);
}
