#include <math.h>

void 
do_grav_hp(const float *p, const float *end, const float *pos0, float *mass0, float *acc0,
	float *phi0, const float *eps2p, int *ncut)
{
    float dr2;
    float r0, r1, r2;
    float phii, mor3, mass;
    float ppos0, ppos1, ppos2;
    float a0, a1, a2;
    float phi;
    float total_mass;
    float eps2 = *eps2p;
    int i, n;

    phi = 0.F;
    total_mass = 0.F;
    a0 = 0.F; a1 = 0.F; a2 = 0.F;
    ppos0 = pos0[0]; ppos1 = pos0[1]; ppos2 = pos0[2];

    n = (end-p)/4;
    for(i=0; i<n; i++){
	mass = *p++;
	r0 = *p++;
	r1 = *p++;
	r2 = *p++;
	r0 -= ppos0;
	r1 -= ppos1;
	r2 -= ppos2;

	dr2 = r0*r0 + r1*r1 +r2*r2;

	dr2 += eps2;		/* 1 flop */

	phii = 1.0F/(float)sqrt(dr2);	/* 1 inverse-sqrt */
	
	mor3 = phii * phii;	/* 5 flops */
	phii *= mass;
	total_mass += mass;
	mor3 *= phii;
	phi -= phii;

	a0 += mor3*r0;
	a1 += mor3*r1;
	a2 += mor3*r2;
    }
    acc0[0] += a0;
    acc0[1] += a1;
    acc0[2] += a2;
    *mass0 += total_mass;
    *phi0 += phi;
}
