/*
 * Copyright 1991 Michael S. Warren and John K. Salmon.  All Rights Reserved.
 */

#ifndef physics_NdotH
#define physics_NdotH

#include "tree.h"
#include "key.h"
#include "keycvt.h"
#include "timers.h"

#define KEY_ORDER PH_ORDER

#define NDIM 3

typedef struct {
    float mass;			/* mass of body */
    float pos[NDIM];		/* position of body */
    float vel[NDIM];		/* velocity of body */
} body;

#define Mass(x) ((x)->mass)
#define Pos(x)  ((x)->pos)

/* In main_n.c */
float Znow(float time);
float Hnow(float time);
float Anow(float time);
extern Timer_t StepTot;
extern Timer_t BuildTot;
extern Timer_t FindForcesTm;
extern Counter_t NbodyCnt;
extern Counter_t NtermsCnt;
extern tbbox UniverseBbox;
/* The following are external so they can be used by GlobalDiags */
extern body point_mass;
extern int do_point_mass;
extern int cosmology;
extern float tpos;
extern float tvel;
extern int log_time;
extern float dt;
extern float sysradius;

/* In cubeimage.c */
extern void cubeimage(int npix, int nobj, body *btab, const char *base);
extern void eaimage(int npix, int nobj, body *btab, const char *base);
#endif
